@echo off
prompt $g
cls
for %%a in (OneLine OneLineA WorkingAccount TrimmedOrig CurLoc RF PathOnly) do set %%a=
for %%a in (*.txt *.log) do if exist "%%a" del /q %%a
if /i not exist "TargetFolders.dat" (echo the file "TargetFolders.dat" is missing. Aborting run. > TestSec.Log) & goto :end

echo The following locations were designated to be tested per "TargetFolders.dat": > TestSec.Log
type TargetFolders.dat>> TestSec.log
echo ------------------------------------>> TestSec.log
echo ------------------------------------>> TestSec.log
echo.>>TestSec.Log
echo.>>TestSec.Log


:SummaryTest
REM :SummaryTest
testsec /s 2>NUL


:DCOMTest
REM :DCOMTest
@echo                          ... >> testsec.log
@echo                          ... >> testsec.log
testsec /d DefaultLaunchPermission
@echo                          ... >> testsec.log
testsec /d DefaultAccessPermission
@echo                          ... >> testsec.log
testsec /d DefaultConfigurationPermission
@echo                          ... >> testsec.log
testsec /d defaultimpersonationlevel
@echo                          ... >> testsec.log
@echo                          ... >> testsec.log


:TestDesigFolders
REM :TestDesigFolders
for /f "Delims=$" %%a in (TargetFolders.dat) do call :TestingDir "%%a"
if /i exist "testsec.log" for /f "Delims=$" %%a in (testsec.log) do call :ANSICLeanup "%%a"
goto :end


:TestingDir
REM :TestingDir
if exist PFSDir.txt del /q PFSDir.txt
if %1=="" goto :eof
set CurLoc=
set CurLoc=%1
if "%CurLoc:~1,1%"==";" goto :eof

for %%a in (RF pathOnly) do set %%a=

if /i "%CurLoc:~1,2%"=="hk" (set RF=R) & goto :TestLoc
if /i "%CurLoc:~1,1%"=="@" Set PathOnly=1
if not defined PathOnly goto :TestLoc

set CurLoc=%CurLoc:~2%
set CurLoc="%CurLoc:"=%"


:TestLoc
REM :TestLoc
if not defined RF (testsec /f %CurLoc%)
if /i "%RF%"=="R" (set CurLoc=%CurLoc:HKEY_LOCAL_MACHINE=hklm%)
if /i "%RF%"=="R" (set CurLoc=%CurLoc:HKEY_CURRENT_USER=hkcu%)
if /i "%RF%"=="R" (set CurLoc=%CurLoc:HKEY_CLASSES_ROOT=hkcr%)
if /i "%RF%"=="R" (set CurLoc=%CurLoc:HKEY_CURRENT_CONFIG=hkcc%)
if /i "%RF%"=="R" (testsec /k %CurLoc%)
@echo ...                          ...>> testsec.log
@echo ...                          ...>> testsec.log

if /i "%RF%"=="R" goto :eof
if defined PathOnly goto :eof

dir /b /ad /s %CurLoc% > PFSDir.txt
if not exist PFSDir.txt goto :eof
for /f "delims=$" %%a in (PFSDir.txt) do call :TestPFSFolder "%%a"
if /i exist PFSDir.txt del /q PFSDir.txt
goto :eof


:TestPFSFolder
REM :TestPFSFolder
set OneLine=
set OneLine=%1
if not defined OneLine goto :eof
if %OneLine%=="" goto :eof
set OneLine=%OneLine:"=%
testsec /f %OneLine%
@echo ...                          ... >> testsec.log
@echo ...                          ... >> testsec.log
goto :eof


:ANSICLeanup
REM :ANSICLeanup
for %%a in (OneLine OneLineA WorkingAccount TrimmedOrig testcount itemcountfirst) do set %%a=
for %%a in (TrimmedOrig.txt OneLine.txt) do if exist "%%a" del /q %%a
set OneLine=%1
if not defined OneLine (set OneLineA= ) & goto :PrintLine
if %OneLine%=="" (set OneLineA= ) & goto :PrintLine
if %OneLine%==" " (set OneLineA= ) & goto :PrintLine

Verify>NUL
echo %OneLine% | find "... " >NUL
if %errorlevel%==0 (Set OneLineA=%OneLine:"=%) & goto :PrintLine

Verify>NUL
echo %OneLine% | find "---------------" >NUL
if %errorlevel%==0 (Set OneLineA=%OneLine:"=%) & goto :PrintLine

REM Trim all leading spaces from OneLine and dump in TrimmedOrig
if exist TrimmedOrig.txt del /q TrimmedOrig.txt
esugregex -replace -regex "^\s*" -string %OneLine% -sub "" > TrimmedOrig.txt
for /f "Delims=@" %%a in (TrimmedOrig.txt) do set TrimmedOrig="%%a"
if exist TrimmedOrig.txt del /q TrimmedOrig.txt
set TrimmedOrig=%TrimmedOrig:"=%
if "%TrimmedOrig%"=="" (set OneLineA= ) & goto :PrintLine

REM Trim all trailing spaces from TrimmedOrig and dump in TrimmedOrig
if exist TrimmedOrig.txt del /q TrimmedOrig.txt
esugregex -replace -regex "$\s*" -string "%TrimmedOrig%" -sub "" > TrimmedOrig.txt
for /f "Delims=@" %%a in (TrimmedOrig.txt) do set TrimmedOrig="%%a"
if exist TrimmedOrig.txt del /q TrimmedOrig.txt
set TrimmedOrig=%TrimmedOrig:"=%
if "%TrimmedOrig%"=="" (set OneLineA= ) & goto :PrintLine

set TrimmedOrig="%TrimmedOrig:"=%"
set TrimmedOrig=%TrimmedOrig:" ="%
set TrimmedOrig=%TrimmedOrig: "="%
set OneLineA=%TrimmedOrig%

verify>NUL
echo %OneLineA% | Find /i "because">NUL
if %errorlevel%==0 goto :TruncateAtBecause

set OneLineA=%OneLineA:"=%
goto :PrintLine

:TruncateAtBecause
REM :TruncateAtBecause
if %OneLineA%=="" goto :PrintLine
for %%a in (newline item TrimmedOrig OneLine) do set %%a=
set itemcountfirst=1
set OneLineA="%OneLineA:"=%"

:FindBecause
Rem :FindBecause
REM This routine is used because TestSec, when reading the drive in a remote condition, can generate unintelligable results.
REM This routine replaces any garbage chars with readable text.
call set item=%%OneLineA:~%itemcountfirst%,1%%
if /i not "%item%"=="b" (set /a itemcountfirst=%itemcountfirst%+1) & goto :FindBecause

set /a testcount=%itemcountfirst%+1
call set testitem=%%OneLineA:~%testcount%,1%%
if /i not "%testitem%"=="e" (set /a itemcountfirst=%itemcountfirst%+1) & goto :FindBecause

set /a testcount=%itemcountfirst%+2
call set testitem=%%OneLineA:~%testcount%,1%%
if /i not "%testitem%"=="c" (set /a itemcountfirst=%itemcountfirst%+1) & goto :FindBecause

set /a testcount=%itemcountfirst%+3
call set testitem=%%OneLineA:~%testcount%,1%%
if /i not "%testitem%"=="a" (set /a itemcountfirst=%itemcountfirst%+1) & goto :FindBecause

set /a itemcountfirst=%itemcountfirst%-1
call set newline=%%OneLineA:~0,%itemcountfirst%%%

set OneLineA=%NewLine% because of Non-Admin - Unknown reason.

for %%a in (newline item itemcountfirst TrimmedOrig) do set %%a=

set OneLineA="%OneLineA:"=%"
set OneLineA=%OneLineA:" ="%
set OneLineA=%OneLineA: "="%
set OneLineA=%OneLineA:"=%
if "%OneLineA%"=="" (set OneLineA= )


:PrintLine
REM :PrintLine
if "%OneLineA%"=="" (set OneLineA= )
echo.%OneLineA%>> testsec.txt
for %%a in (OneLine OneLineA WorkingAccount) do set %%a=
for %%a in (TrimmedOrig.txt OneLine.txt) do if exist "%%a" del /q %%a
goto :eof

:End
REM :End
for %%a in (OneLine OneLineA WorkingAccount RF CurLoc PathOnly) do set %%a=
for %%a in (TrimmedOrig.txt OneLine.txt testsec.log PFSDir.txt) do if exist "%%a" del /q %%a
